## coq-elpi 2.5.0

=== Makefile ===
dune_wrap = $(shell command -v coqc > /dev/null || echo "etc/with-rocq-wrap.sh")
dune = $(dune_wrap) dune $(1) $(DUNE_$(1)_FLAGS --stop-on-first-error
DUNE_IN_FILES = $(shell find . -name "dune.in" | sed -e 's/.in$$//')

all: $(DUNE_IN_FILES)
	$(call dune,build)
	$(call dune,build) builtin-doc
.PHONY: all

# simplify this and get rid of the dune.in files once we require Rocq >= 9.0
%dune: %dune.in
	@rm -f $@
	@echo "; generated by make, do not edit\n" > $@
	@if test -e .coq-dune-files || \
	    (command -v coqc > /dev/null && (coqc --version | grep -q '8.19\|8.20')) ; then \
	  sed -e 's/@@STDLIB_THEORY@@//' $< | \
	  sed -e 's/@@STDLIB@@//' | \
	  sed -e 's/@@ROCQ_RUNTIME@@/coq-core/g' >> $@ ; \
	else \
	  sed -e 's/@@STDLIB_THEORY@@/(theories Stdlib)/' $< | \
	  sed -e 's/@@STDLIB@@/Stdlib/' | \
	  sed -e 's/@@ROCQ_RUNTIME@@/rocq-runtime/g' >> $@ ; \
	fi
	@chmod a-w $@

dune-files: $(DUNE_IN_FILES)
.PHONE: dune-files

coq-dune-files:
	touch .coq-dune-files
	$(MAKE) dune-files
	$(RM) .coq-dune-files
.PHONE: coq-dune-files

build-core: $(DUNE_IN_FILES)
	$(call dune,build) theories
	$(call dune,build) builtin-doc
.PHONY: build-core

build-apps: $(DUNE_IN_FILES)
	$(call dune,build) $$(find apps -type d -name theories)
.PHONY: build-apps

build: $(DUNE_IN_FILES)
	$(call dune,build) -p rocq-elpi @install
	$(call dune,build) builtin-doc
.PHONY: build

all-tests: test-core test-stdlib test-apps test-apps-stdlib
.PHONY: all-tests

test-core: $(DUNE_IN_FILES)
	$(call dune,runtest) tests
	$(call dune,build) tests
.PHONY: test-core

test-apps: $(DUNE_IN_FILES)
	$(call dune,build) $$(find apps -type d -name tests)
.PHONY: test-apps

test-apps-stdlib: $(DUNE_IN_FILES)
	$(call dune,build) $$(find apps -type d -name tests-stdlib)
.PHONY: test-apps-stdlib

test-stdlib: $(DUNE_IN_FILES)
	$(call dune,build) tests-stdlib
.PHONY: test-stdlib

all-examples: examples examples-stdlib
.PHONY: all-examples

examples: $(DUNE_IN_FILES)
	$(call dune,build) examples
.PHONY: examples

examples-stdlib: theories-stdlib/dune
	$(call dune,build) examples-stdlib
.PHONY: examples-stdlib

doc: build
	@echo "########################## generating doc ##########################"
	@mkdir -p doc
	@$(foreach tut,$(wildcard examples/tutorial*$(ONLY)*.v),\
		echo ALECTRYON $(tut) && OCAMLPATH=$(shell pwd)/_build/install/default/lib ./etc/alectryon_elpi.py \
		    --frontend coq+rst \
			--output-directory doc \
		    --pygments-style vs \
			-R $(shell pwd)/_build/install/default/lib/coq/user-contrib/elpi_elpi elpi_elpi \
			-R $(shell pwd)/_build/install/default/lib/coq/user-contrib/elpi elpi \
			$(tut) &&) true
	@cp ./_build/default/examples/stlc.txt doc/
	@cp etc/tracer.png doc/

clean:
	$(call dune,clean)
.PHONY: clean

install: $(DUNE_IN_FILES)
	$(call dune,install) rocq-elpi
.PHONY: install

nix:
	nix-shell --arg do-nothing true --run "updateNixToolBox && genNixActions"
.PHONY: nix

=== debian/changelog ===
coq-elpi (2.5.0-1.1ubuntu1) resolute; urgency=medium

  * Increase a little bit more a test timeout

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 24 Oct 2025 20:06:25 +0200

coq-elpi (2.5.0-1.1build3) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 24 Oct 2025 06:52:43 +0200

coq-elpi (2.5.0-1.1build2) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 22 Oct 2025 22:45:30 +0200

coq-elpi (2.5.0-1.1build1) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 31 Aug 2025 21:18:48 +0200

coq-elpi (2.5.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Enable again a patch commented on new release

  [ Adrian Bunk <bunk@debian.org> ]
  * Add 0001-Increase-a-test-timeout.patch
    (Closes: #1107826)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 17 Jun 2025 08:59:01 +0200

coq-elpi (2.5.0-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 12 Mar 2025 08:06:26 +0100

=== debian/control ===
Source: coq-elpi
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Julien Puydt <jpuydt@debian.org>
Section: ocaml
Priority: optional
Standards-Version: 4.7.0
Rules-Requires-Root: no
Build-Depends: coq,
               debhelper-compat (= 13),
               dh-coq,
               dh-ocaml,
               elpi,
               libcoq-core-ocaml-dev (>= 8.17),
               libcoq-stdlib,
               libelpi-ocaml-dev,
               libppx-optcomp-ocaml-dev,
               ocaml-dune
Vcs-Browser: https://salsa.debian.org/ocaml-team/coq-elpi
Vcs-Git: https://salsa.debian.org/ocaml-team/coq-elpi.git
Homepage: https://github.com/LPCIC/coq-elpi

Package: libcoq-elpi
Architecture: any
Depends: libelpi-ocaml-dev, ${coq:Depends}, ${misc:Depends}, ${ocaml:Depends}
Provides: ${coq:Provides}
Description: Coq plugin embedding Elpi
 This package makes it possible to define new commands and tactics
 for Coq in Elpi.
 .
 Elpi implements a lambda-Prolog interpreter enriched with
 constraint handling rules.
 .
 Coq is a proof assistant for higher-order logic.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk
include /usr/share/coq/coqvars.mk

export COQTOP := $(COQ_STDLIB_DIR)
export COQLIB := $(COQ_STDLIB_DIR)
export COQBIN := /usr/bin
export ELPIDIR := $(OCAML_STDLIB_DIR)/elpi

%:
	dh $@ --with ocaml,coq

override_dh_auto_build:
	make

override_dh_auto_clean:
	dune clean


override_dh_auto_install:
	dune install rocq-elpi --destdir=$(CURDIR)/debian/tmp --prefix=/usr --libdir=$(OCAML_STDLIB_DIR)
	rm -fr $(CURDIR)/debian/tmp/usr/doc/coq-elpi
	rm -fr $(CURDIR)/debian/tmp/usr/doc/rocq-elpi

override_dh_ocaml:
	dh_ocaml --nodefined-map=libcoq-elpi-ocaml-dev:Elpi_parser,Elpi_util,Elpi_parser__Ast,Elpi__Runtime,Elpi__,Elpi_util__Util,Elpi__Builtin_checker,Elpi__Builtin,Elpi__Ptmap,Elpi_parser__Grammar,Elpi__Data,Elpi_lexer_config,Elpi__API,Elpi_parser__Parse,Elpi__Builtin_set,Trace_ppx_runtime,Elpi_parser__Parser_config,Elpi_parser__Error_messages,Elpi_parser__Lexer,Elpi,Elpi_exer_config__Tokens,Elpi_Builtin_stdlib,Elpi__Legacy_parser_proxy,Elpi__Builtin_map,Elpi_lexer_config__Tokens,Elpi__Compiler,Trace_ppx_runtime__Runtime,Elpi_lexer_config__Lexer_config,Elpi__Builtin_stdlib,Elpi__Runtime_trace_off,MenhirLib,Ppx_deriving_runtime,Re__Perl,Re__Core,Re__Pcre,Re_str,Re__Automata,Re__Emacs,Re,Re__Fmt,Re__Group,Re__,Re__Glob,Re__Pmark,Re__Category,Re__Str,Re__Posix,Re__Color_map,Re__Cset,Result

## coq-elpi 3.2.0

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,10 @@
 dune_wrap = $(shell command -v coqc > /dev/null || echo "etc/with-rocq-wrap.sh")
-dune = $(dune_wrap) dune $(1) $(DUNE_$(1)_FLAGS --stop-on-first-error
+dune = $(dune_wrap) dune $(1) $(DUNE_$(1)_FLAGS) --stop-on-first-error
 DUNE_IN_FILES = $(shell find . -name "dune.in" | sed -e 's/.in$$//')
+
+# This makefile is mostly calling dune and dune doesn't like
+# being called in parralel, so we enforce -j1
+.NOTPARALLEL:
 
 all: $(DUNE_IN_FILES)
 	$(call dune,build)
@@ -12,7 +16,7 @@
 	@rm -f $@
 	@echo "; generated by make, do not edit\n" > $@
 	@if test -e .coq-dune-files || \
-	    (command -v coqc > /dev/null && (coqc --version | grep -q '8.19\|8.20')) ; then \
+	    (command -v coqc > /dev/null && (coqc --version | grep -q '8.20')) ; then \
 	  sed -e 's/@@STDLIB_THEORY@@//' $< | \
 	  sed -e 's/@@STDLIB@@//' | \
 	  sed -e 's/@@ROCQ_RUNTIME@@/coq-core/g' >> $@ ; \
@@ -52,6 +56,13 @@
 test-core: $(DUNE_IN_FILES)
 	$(call dune,runtest) tests
 	$(call dune,build) tests
+	# Check for build reproducibility
+	md5sum _build/default/tests/accumulate1.vo > md5sum_accumulate1vo_1
+	rm -f _build/default/tests/accumulate1.vo
+	$(call dune,build) --cache=disabled tests
+	md5sum _build/default/tests/accumulate1.vo > md5sum_accumulate1vo_2
+	diff md5sum_accumulate1vo_1 md5sum_accumulate1vo_2
+	rm md5sum_accumulate1vo_1 md5sum_accumulate1vo_2
 .PHONY: test-core
 
 test-apps: $(DUNE_IN_FILES)
@@ -79,9 +90,11 @@
 
 doc: build
 	@echo "########################## generating doc ##########################"
+	@python3 -m venv alectryon
+	@alectryon/bin/pip3 install git+https://github.com/cpitclaudel/alectryon.git@c8ab1ec
 	@mkdir -p doc
 	@$(foreach tut,$(wildcard examples/tutorial*$(ONLY)*.v),\
-		echo ALECTRYON $(tut) && OCAMLPATH=$(shell pwd)/_build/install/default/lib ./etc/alectryon_elpi.py \
+		echo ALECTRYON $(tut) && OCAMLPATH=$(shell pwd)/_build/install/default/lib alectryon/bin/python3 etc/alectryon_elpi.py \
 		    --frontend coq+rst \
 			--output-directory doc \
 		    --pygments-style vs \

=== debian/changelog ===
coq-elpi (3.2.0-2) experimental; urgency=medium

  * Add missing depends on shlibs:Depends.
  * Bump standards-version to 4.7.2.

 -- Julien Puydt <jpuydt@debian.org>  Thu, 30 Oct 2025 08:44:33 +0100

coq-elpi (3.2.0-1) experimental; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 29 Oct 2025 08:58:28 +0100

coq-elpi (2.5.0-1.2) unstable; urgency=medium

  * Increase a little bit more a test timeout

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 24 Oct 2025 20:06:25 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Julien Puydt <jpuydt@debian.org>
 Section: ocaml
 Priority: optional
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Build-Depends: coq,
                debhelper-compat (= 13),
@@ -21,7 +21,7 @@
 
 Package: libcoq-elpi
 Architecture: any
-Depends: libelpi-ocaml-dev, ${coq:Depends}, ${misc:Depends}, ${ocaml:Depends}
+Depends: libelpi-ocaml-dev, ${coq:Depends}, ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
 Provides: ${coq:Provides}
 Description: Coq plugin embedding Elpi
  This package makes it possible to define new commands and tactics

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,8 @@
 
 include /usr/share/ocaml/ocamlvars.mk
 include /usr/share/coq/coqvars.mk
+
+export DEB_BUILD_OPTIONS += noautodbgsym
 
 export COQTOP := $(COQ_STDLIB_DIR)
 export COQLIB := $(COQ_STDLIB_DIR)
